include \masm32\include\masm32rt.inc

include hexadump.asm

.data
  szFile        db "Test.txt",0
  szStartstring db "str1=",0
  szt           db "str2=",0
  counter       db 0
.data?
  hInstance     dd ?
  ; integer sizes
  nReadBytes    dd  ?                 ;
  hSearch       dd  ?                 ; handles
  hFiles        dd  ?                 ;
  hBuffer       dd  ?
  @_Item1       db 512 dup (?)
  sLength       DWORD ?
  tLength       DWORD ?

.code
start:

    invoke CreateFile,offset szFile,GENERIC_READ or GENERIC_WRITE,\
                                    FILE_SHARE_READ or FILE_SHARE_WRITE,0,\
                                    OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,0
    mov hFiles,eax
  Read:
    invoke ReadFile,hFiles,addr hBuffer,500,addr nReadBytes,0
    invoke lstrcpy,addr hSearch ,addr szStartstring
  next:
    push offset hSearch
    push offset hBuffer
    call Str_find

    push eax
    invoke HexAsciiDump, eax, 40
    print eax,13,10
    pop eax

    mov ah,byte ptr [eax]
    mov edx,256
    mov edi,offset @_Item1
    mov ah,byte ptr [esi]
  @ReadText:
    mov byte ptr [edi],ah
    dec edx
    jz  @ret
    inc esi
    inc edi
    mov ah,byte ptr [esi]
    cmp ah,'&'
    jne @ReadText
    mov byte ptr [edi],0
    invoke MessageBox,0,addr @_Item1,0,MB_OK ; replaced hWnd with 0
    inc counter
    cmp counter,2
    je @ret
    invoke lstrcpy,addr hSearch ,addr szt
    jmp next
  @ret:
    inkey "Press any key to exit..."
    exit

Str_find PROC sourcePtr:PTR BYTE, targetPtr:PTR BYTE

          mov eax, sourcePtr
          mov ebx, targetPtr
          mov esi, targetPtr
          xor ecx, ecx
   L0:
          cmp BYTE PTR [esi], 0
          je L1
          inc esi
          inc ecx
          jmp L0
   L1:
          mov edx, ecx
   L2:
          mov esi, eax
          mov edi, ebx
          repe cmpsb
          jz FOUND
          mov ecx, edx
          cmp BYTE PTR [eax + ecx], 0
          jz NOT_FOUND
          inc eax
          jmp L2
  NOT_FOUND:
          or eax, 1
          ret
  FOUND:
          mov tLength,edx
          sub esi,tLength
          ret
Str_find ENDP

end start